\hypertarget{timl_8h}{\section{timl.\-h File Reference}
\label{timl_8h}\index{timl.\-h@{timl.\-h}}
}


timl public A\-P\-Is  


{\ttfamily \#include \char`\"{}timl\-Util.\-h\char`\"{}}\\*
{\ttfamily \#include \char`\"{}timl\-C\-N\-N.\-h\char`\"{}}\\*
\subsection*{Functions}
{\bf }\par
\begin{DoxyCompactItemize}
\item 
\hyperlink{structtimlCNNInputParams}{timl\-C\-N\-N\-Input\-Params} \hyperlink{group__cnn_ga71b91e772f1e63528e53a6284ba7b879}{timl\-C\-N\-N\-Input\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the input layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNConvParams}{timl\-C\-N\-N\-Conv\-Params} \hyperlink{group__cnn_ga33ddb7145ae4e19ea52e12576f4871aa}{timl\-C\-N\-N\-Conv\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the convolutional layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNLinearParams}{timl\-C\-N\-N\-Linear\-Params} \hyperlink{group__cnn_gad5c8fd10f11ccaa8142a665fc8ee93b8}{timl\-C\-N\-N\-Linear\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the linear layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNPoolingParams}{timl\-C\-N\-N\-Pooling\-Params} \hyperlink{group__cnn_gacd163e268b3ccc9805bcca59689a36f5}{timl\-C\-N\-N\-Pooling\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the pooling layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNNonlinearParams}{timl\-C\-N\-N\-Nonlinear\-Params} \hyperlink{group__cnn_ga24aaf5f0c47a32c8223073f22c88c184}{timl\-C\-N\-N\-Nonlinear\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the nonlinear layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNNormParams}{timl\-C\-N\-N\-Norm\-Params} \hyperlink{group__cnn_ga03ee34f7d893af02536bcbf2d071f721}{timl\-C\-N\-N\-Norm\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default parameters for the norm layer. \end{DoxyCompactList}\item 
\hyperlink{structtimlCNNTrainingParams}{timl\-C\-N\-N\-Training\-Params} \hyperlink{group__cnn_gaaf7a5b272ae2ba5d0453f214afaab747}{timl\-C\-N\-N\-Training\-Params\-Default} ()
\begin{DoxyCompactList}\small\item\em Return the default training parameters. \end{DoxyCompactList}\item 
\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$ \hyperlink{group__cnn_gaf75b4687f4b493b8a85bc7fcc37bdf18}{timl\-C\-N\-N\-Create\-Conv\-Neural\-Network} (\hyperlink{structtimlCNNTrainingParams}{timl\-C\-N\-N\-Training\-Params} params, int device\-Id)
\begin{DoxyCompactList}\small\item\em Create a cnn structure. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga253033ab06b21f2bf28301bc1e53c419}{timl\-C\-N\-N\-Add\-Input\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int feature\-Map\-Row, int feature\-Map\-Col, int feature\-Map\-Channel, \hyperlink{structtimlCNNInputParams}{timl\-C\-N\-N\-Input\-Params} params)
\begin{DoxyCompactList}\small\item\em Add input layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gab5dcc5ac470e15bea85f0a5570eec37d}{timl\-C\-N\-N\-Add\-Pooling\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int scale\-Row, int scale\-Col, int stride\-X, int stride\-Y, timl\-C\-N\-N\-Pooling\-Type type, \hyperlink{structtimlCNNPoolingParams}{timl\-C\-N\-N\-Pooling\-Params} params)
\begin{DoxyCompactList}\small\item\em Add pooling layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga7627fe7a5294d7c8cac75d974b78a27a}{timl\-C\-N\-N\-Add\-Norm\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, \hyperlink{structtimlCNNNormParams}{timl\-C\-N\-N\-Norm\-Params} params)
\begin{DoxyCompactList}\small\item\em Add normalization layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga772bc4b21c2f800ee8ac5248a732f116}{timl\-C\-N\-N\-Add\-Conv\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int kernel\-Row, int kernel\-Col, int stride\-X, int stride\-Y, int feature\-Map\-Channel, \hyperlink{structtimlCNNConvParams}{timl\-C\-N\-N\-Conv\-Params} params)
\begin{DoxyCompactList}\small\item\em Add conv layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gaddfd98d23613318bdc368eac98fddf0b}{timl\-C\-N\-N\-Add\-Nonlinear\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, timl\-Util\-Activation\-Type type)
\begin{DoxyCompactList}\small\item\em Add nonlinear layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga0219ba397301c5fb3eedfb64e62e33bc}{timl\-C\-N\-N\-Add\-Linear\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int dim, \hyperlink{structtimlCNNLinearParams}{timl\-C\-N\-N\-Linear\-Params} params)
\begin{DoxyCompactList}\small\item\em Add linear layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gae988ef172bde701db59b1cfc33dd50ab}{timl\-C\-N\-N\-Add\-Dropout\-Layer} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, float prob)
\begin{DoxyCompactList}\small\item\em Add dropout layer. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga666fa0a68b725aa1e35dba659ba7c5f9}{timl\-C\-N\-N\-Initialize} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Allocate the memory required by the cnn. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga21bc0c855cb658f51fe5d6911acddb54}{timl\-C\-N\-N\-Reset} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Reset the parameters of the C\-N\-N. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga5af48b599237f48f016ce2060c6053e1}{timl\-C\-N\-N\-Delete} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Free a cnn structure. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga9198f6379fad0e9e45dd8f64cc030ec3}{timl\-C\-N\-N\-Supervised\-Training\-With\-Label\-Batch\-Mode} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, float $\ast$data, int $\ast$label, int dim, int num)
\begin{DoxyCompactList}\small\item\em Supervised training with label. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga8b59ecbca36e54cfa1df0766ece686b5}{timl\-C\-N\-N\-Classify\-Top\-N\-Batch\-Mode} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, float $\ast$data, int dim, int num, int $\ast$label, float $\ast$percent, int top\-N)
\begin{DoxyCompactList}\small\item\em Batch classification. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gafda5077b0d39c278469278b37f845aed}{timl\-C\-N\-N\-Classify\-Top1\-Single\-Mode} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, float $\ast$data, int dim)
\begin{DoxyCompactList}\small\item\em Classify the data. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga04d9a7e3725ce777402e1e5c4d5d4ce0}{timl\-C\-N\-N\-Set\-Mode} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, timl\-Util\-Phase phase)
\begin{DoxyCompactList}\small\item\em Set the phase (train/test) of the cnn. \end{DoxyCompactList}\item 
\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$ \hyperlink{group__cnn_ga409c28e6bb3633f1de65647b790aa320}{timl\-C\-N\-N\-Clone} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int device\-Id)
\begin{DoxyCompactList}\small\item\em Clone a cnn. \end{DoxyCompactList}\item 
\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$ \hyperlink{group__cnn_ga52826c14f9f1913947f5ca6937b5afd5}{timl\-C\-N\-N\-Share\-Params} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int device\-Id)
\begin{DoxyCompactList}\small\item\em Create a new C\-N\-N that shares the parameters with the input C\-N\-N. \end{DoxyCompactList}\item 
long \hyperlink{group__cnn_ga2e8a7e765f885a236e40dfaed59913c6}{timl\-C\-N\-N\-Memory} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Return the memory in bytes required by the cnn. \end{DoxyCompactList}\item 
long \hyperlink{group__cnn_ga72df82405eb43be8bb75373aaf8ec101}{timl\-C\-N\-N\-Get\-Params\-Num} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Get the number of parameters of the cnn. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gad7f3f988c763fe5a80826439c9fb08bd}{timl\-C\-N\-N\-Write\-To\-File} (const char $\ast$file\-Name, \hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, \hyperlink{group__util_ga8e44b2a87636024736da04ae5a53c1c9}{timl\-Util\-Params\-Level} params\-Level, const char $\ast$name, const char $\ast$float\-Format, const char $\ast$int\-Format)
\begin{DoxyCompactList}\small\item\em Write the cnn to file(s) \end{DoxyCompactList}\item 
\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$ \hyperlink{group__cnn_gabab7c3c18a2fa4a3a9985da42662682c}{timl\-C\-N\-N\-Read\-From\-File} (const char $\ast$file\-Name, int device\-Id)
\begin{DoxyCompactList}\small\item\em Read C\-N\-N from file(s) \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga123557b8025497fe266d58d80ee9983b}{timl\-C\-N\-N\-Print} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Print out the information of the cnn. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga13c723ecb589f7da7e01a9cd9591061d}{timl\-C\-N\-N\-Profile} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, float $\ast$data, int dim, int num, int $\ast$label, int iter)
\begin{DoxyCompactList}\small\item\em Profile the C\-N\-N with both timing and memory allocation. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_ga78addba765ea7dd8bf958d19d42be931}{timl\-C\-N\-N\-Resize} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn, int row, int col, int channel)
\begin{DoxyCompactList}\small\item\em Resize the feature map sizes to accommodate new input feature map dimensions. \end{DoxyCompactList}\item 
int \hyperlink{group__cnn_gaf65f8d45c892f70eeee34b47791bdcb5}{timl\-C\-N\-N\-Get\-Layer\-Num} (\hyperlink{struct__timlConvNeuralNetwork__}{timl\-Conv\-Neural\-Network} $\ast$cnn)
\begin{DoxyCompactList}\small\item\em Return the number of layers of the cnn. \end{DoxyCompactList}\end{DoxyCompactItemize}



\subsection{Detailed Description}
timl public A\-P\-Is 